namespace SingingSunflower
{
	using System;
	//using System.Collections.Generic;
	//using System.Diagnostics;
	//using System.Drawing;
	//using System.Globalization;
	//using System.IO;
	using System.Linq;
	//using System.Media;
	//using System.Net;
	//using System.Runtime.InteropServices;
	//using System.Text.RegularExpressions;
	//using System.Threading;
	//using System.Windows.Forms;
	using System.Windows.Media;
	//using System.Xml;
	//using System.Xml.Linq;
	
	using Styx;
	using Styx.Common;
	//using Styx.Common.Helpers;
	//using Styx.CommonBot;
	//using Styx.CommonBot.Frames;
	//using Styx.CommonBot.Inventory;
	//using Styx.CommonBot.POI;
	//using Styx.CommonBot.Profiles;
	//using Styx.Helpers;
	//using Styx.Localization;
	//using Styx.Pathing;
	using Styx.Plugins;
	using Styx.WoWInternals;
	//using Styx.WoWInternals.DBC;
	using Styx.WoWInternals.WoWObjects;
	
	//using GreyMagic;
	//using Bots.ArchaeologyBuddy;

    public class SingingSunflower : HBPlugin
    {
        public override string Name { get { return "Singing Sunflower Helper"; } }
        public override string Author { get { return "Proto"; } }
        public override Version Version { get { return new Version(1, 0); } }
        public override bool WantButton { get { return true; } }
        public override string ButtonText { get { return "None"; } }
		public override void OnEnable()
        {
            Logging.Write(Colors.Orange, "Singing Sunflower Helper - Enabled"); 
            base.OnEnable(); 
        }
        public override void OnDisable()
		{
            Logging.Write(Colors.OrangeRed, "Singing Sunflower Helper - Disabled"); 
            base.OnDisable(); 
        }
		public static void slog(string format, params object[] args)
        {
            Logging.Write(Colors.Orange, "[Singing Sunflower]: " + format, args); 
        }
        private const int MobId_SolrPowr = 49194; 
		public static int[] MobIds = new[] { MobId_SolrPowr }; 
        private static LocalPlayer Me = StyxWoW.Me; 
        public WoWUnit SolPwr
        {
            get
            {
                return (ObjectManager.GetObjectsOfType<WoWUnit>()
                                     .Where(u => MobIds.Contains((int)u.Entry))
                                     .OrderBy(u => u.Distance).FirstOrDefault()); 
            }
        }
        public override void Pulse()
        {
            if (SolPwr == null)
			{
                return; 
            }
            if (!CanGetSolarPower()) 
			{
                return; 
            }
            if (SolPwr.Entry == MobId_SolrPowr)
			{
                //slog("Getting {0}.", SolPwr.Name); 
				SolPwr.Interact(); 
				StyxWoW.Sleep(250); 
				return; 
            }
        }

        public static bool IsViable(WoWUnit SolPwr) 
		{
            return (SolPwr != null) 
			&& SolPwr.IsValid; 
        }
        public static bool CanGetSolarPower() 
		{
            return IsViable(Me) 
			&& Me.IsOnTransport 
			&& Me.InVehicle; 
			//&& !Me.IsDead
			//&& !Me.IsChanneling 
			//&& !Me.IsCasting 
			//&& !Me.IsFlying 
			//&& !Me.OnTaxi 
			//&& !Me.IsSwimming 
			//&& !Me.IsMoving 
			//&& !Me.Mounted 
			//&& Me.IsOnTransport 
			//&& Me.InVehicle; 
        }
    }
}
